import { BaseComponent } from '../../Utilities';
import { IContextualMenuProps } from '../../ContextualMenu';
import { IButtonProps, IButton } from './Button.Props';
export interface IBaseButtonProps extends IButtonProps {
    baseClassName?: string;
    variantClassName?: string;
}
export interface IBaseButtonState {
    menuProps?: IContextualMenuProps | null;
}
export declare class BaseButton extends BaseComponent<IBaseButtonProps, IBaseButtonState> implements IButton {
    static defaultProps: {
        baseClassName: string;
        classNames: {};
        styles: {};
    };
    private _buttonElement;
    private _labelId;
    private _descriptionId;
    private _ariaDescriptionId;
    constructor(props: IBaseButtonProps, rootClassName: string);
    render(): JSX.Element;
    focus(): void;
    private _onRenderContent(tag, buttonProps);
    private _onRenderIcon(buttonProps?, defaultRender?);
    private _onRenderText();
    private _onRenderChildren();
    private _onRenderDescription();
    private _onRenderAriaDescription();
    private _onRenderMenuIcon(props);
    private _onRenderMenu(menuProps);
    private _onToggleMenu();
}
